import 'dart:async';

import 'package:flutter/material.dart';

class GRefreshingWidget extends StatefulWidget {
  final Widget Function() _getRefreshedWidget;

  const GRefreshingWidget(this._getRefreshedWidget, {super.key});

  @override
  GRefreshingWidgetState createState() => GRefreshingWidgetState();
}

class GRefreshingWidgetState extends State<GRefreshingWidget> {
  late Timer refreshTimer;

  @override
  void initState() {
    super.initState();
    refreshTimer = Timer.periodic(
      const Duration(seconds: 1),
      (timer) => setState(() {}),
    );
  }

  @override
  Widget build(BuildContext context) => widget._getRefreshedWidget();

  @override
  void dispose() {
    super.dispose();
    refreshTimer.cancel();
  }
}
